#include "STM32F4.h"

#include "mamachdep.h"
#include "masound.h"

#include "WAV.h"

extern void MaDevDrv_IntHandler(void);

#define YMU762_RST(x) GPIO_##x##Bits(GPIOB,GPIO_Pin_11)

#define PAUSE GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_0)

#define LED(x) GPIO_##x##Bits(GPIOD,GPIO_Pin_12)

void delay_ms(volatile u32 d)
{
 d*=55000; //-O3 -OTime @168 MHz
 while(d--);
}

void GPIO(void)
{
 GPIO_InitTypeDef gpio;

 RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA|RCC_AHB1Periph_GPIOB|RCC_AHB1Periph_GPIOD|RCC_AHB1Periph_GPIOE,ENABLE);

 //YMU762
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource14,GPIO_AF_FSMC); // D0
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource15,GPIO_AF_FSMC); // D1
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource0 ,GPIO_AF_FSMC); // D2
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource1 ,GPIO_AF_FSMC); // D3
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource7 ,GPIO_AF_FSMC); // D4
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource8 ,GPIO_AF_FSMC); // D5
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource9 ,GPIO_AF_FSMC); // D6
 GPIO_PinAFConfig(GPIOE,GPIO_PinSource10,GPIO_AF_FSMC); // D7
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource11,GPIO_AF_FSMC); //A16 => RS
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource7 ,GPIO_AF_FSMC); //NE1 => CS
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource4 ,GPIO_AF_FSMC); //NOE => RD
 GPIO_PinAFConfig(GPIOD,GPIO_PinSource5 ,GPIO_AF_FSMC); //NWE => WR

 gpio.GPIO_Pin=GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_7|GPIO_Pin_11|GPIO_Pin_14|GPIO_Pin_15;
 gpio.GPIO_Mode=GPIO_Mode_AF;
 gpio.GPIO_Speed=GPIO_Speed_100MHz;
 gpio.GPIO_OType=GPIO_OType_PP;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOD,&gpio);

 gpio.GPIO_Pin=GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10;
 gpio.GPIO_Mode=GPIO_Mode_AF;
 gpio.GPIO_Speed=GPIO_Speed_100MHz;
 gpio.GPIO_OType=GPIO_OType_PP;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOE,&gpio);

 //YMU762 !RST B11
 gpio.GPIO_Pin=GPIO_Pin_11;
 gpio.GPIO_Mode=GPIO_Mode_OUT;
 gpio.GPIO_Speed=GPIO_Speed_2MHz;
 gpio.GPIO_OType=GPIO_OType_PP;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOB,&gpio);

 //YMU762 !IRQ B0
 gpio.GPIO_Pin=GPIO_Pin_0;
 gpio.GPIO_Mode=GPIO_Mode_IN;
 gpio.GPIO_Speed=GPIO_Speed_2MHz;
 gpio.GPIO_OType=GPIO_OType_PP;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOB,&gpio);

 //Pause Button A0
 gpio.GPIO_Pin=GPIO_Pin_0;
 gpio.GPIO_Mode=GPIO_Mode_IN;
 gpio.GPIO_Speed=GPIO_Speed_2MHz;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOA,&gpio);

 //LED TEST D12
 gpio.GPIO_Pin=GPIO_Pin_12;
 gpio.GPIO_Mode=GPIO_Mode_OUT;
 gpio.GPIO_Speed=GPIO_Speed_2MHz;
 gpio.GPIO_OType=GPIO_OType_PP;
 gpio.GPIO_PuPd=GPIO_PuPd_NOPULL;
 GPIO_Init(GPIOD,&gpio);
}

void FSMC(void)
{
 FSMC_NORSRAMTimingInitTypeDef fsmcTiming;
 FSMC_NORSRAMInitTypeDef fsmc;

 RCC_AHB3PeriphClockCmd(RCC_AHB3Periph_FSMC,ENABLE);

 fsmcTiming.FSMC_AddressSetupTime=0;
 fsmcTiming.FSMC_AddressHoldTime=0;
 fsmcTiming.FSMC_DataSetupTime=6; //6 Read, 4 Write
 fsmcTiming.FSMC_BusTurnAroundDuration=0;
 fsmcTiming.FSMC_CLKDivision=0;
 fsmcTiming.FSMC_DataLatency=0;
 fsmcTiming.FSMC_AccessMode=FSMC_AccessMode_A;

 fsmc.FSMC_Bank=FSMC_Bank1_NORSRAM1;
 fsmc.FSMC_DataAddressMux=FSMC_DataAddressMux_Disable;
 fsmc.FSMC_MemoryType=FSMC_MemoryType_SRAM;
 fsmc.FSMC_MemoryDataWidth=FSMC_MemoryDataWidth_8b;
 fsmc.FSMC_BurstAccessMode=FSMC_BurstAccessMode_Disable;
 fsmc.FSMC_WaitSignalPolarity=FSMC_WaitSignalPolarity_Low;
 fsmc.FSMC_WrapMode=FSMC_WrapMode_Disable;
 fsmc.FSMC_WaitSignalActive=FSMC_WaitSignalActive_BeforeWaitState;
 fsmc.FSMC_WriteOperation=FSMC_WriteOperation_Enable;
 fsmc.FSMC_WaitSignal=FSMC_WaitSignal_Disable;
 fsmc.FSMC_AsynchronousWait=FSMC_AsynchronousWait_Disable;
 fsmc.FSMC_ExtendedMode=FSMC_ExtendedMode_Disable;
 fsmc.FSMC_WriteBurst=FSMC_WriteBurst_Disable;
 fsmc.FSMC_ReadWriteTimingStruct=&fsmcTiming;
 fsmc.FSMC_WriteTimingStruct=&fsmcTiming;

 FSMC_NORSRAMInit(&fsmc); 
 FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM1,ENABLE);
}

void IRQ()
{
 EXTI_InitTypeDef exti;
 NVIC_InitTypeDef nvic;

 RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG,ENABLE);

 //YMF762 IRQ B0
 SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOB,EXTI_PinSource0);

 exti.EXTI_Line=EXTI_Line0;
 exti.EXTI_LineCmd=ENABLE;
 exti.EXTI_Mode=EXTI_Mode_Interrupt;
 exti.EXTI_Trigger=EXTI_Trigger_Falling;
 EXTI_Init(&exti);

 EXTI_ClearITPendingBit(EXTI_Line0);

 nvic.NVIC_IRQChannel=EXTI0_IRQn;
 nvic.NVIC_IRQChannelPreemptionPriority=0;
 nvic.NVIC_IRQChannelSubPriority=0;
 nvic.NVIC_IRQChannelCmd=ENABLE;
 NVIC_Init(&nvic);
}

void EXTI0_IRQHandler()
{
 static u8 t=0;

 EXTI_ClearITPendingBit(EXTI_Line0);

 MaDevDrv_IntHandler();

 t^=1;

 if(t)LED(Set);
 else LED(Reset);
}

void YMU762_Reset(void)
{
 YMU762_RST(Reset);
 delay_ms(10);
 YMU762_RST(Set);
 delay_ms(1);
}

signed long CallBack(unsigned char id)
{
 /*
 switch(id)
 {
  case MASMW_REPEAT:
  break;
  case MASMW_END_OF_SEQUENCE:
  break;
  default:
  break;
 }
 */
 return MASMW_SUCCESS;
}

int main(void)
{
 GPIO();
 FSMC();

 YMU762_Reset();

 IRQ();

 MaSound_Initialize();

 MaSound_DeviceControl(MASMW_HP_VOLUME, 0,0,0);
 MaSound_DeviceControl(MASMW_EQ_VOLUME,31,0,0);
 MaSound_DeviceControl(MASMW_SP_VOLUME,23,0,0);

 s32 func=MaSound_Create(MASMW_CNVID_WAV);
 s32 file=MaSound_Load(func,(u8*)WAV,sizeof(WAV),1,CallBack,NULL);

 MaSound_Open(func,file,0,NULL);

 u8 volume=127; //Max 0 dB
 MaSound_Control(func,file,MASMW_SET_VOLUME,&volume,NULL);

 MaSound_Standby(func,file,NULL);
 MaSound_Start(func,file,0,NULL); //Play Loop

 Loop:

 if(PAUSE)
 {
  MaSound_Pause(func,file,NULL);
  delay_ms(100);
  while(PAUSE);
  delay_ms(100);
  while(!PAUSE);
  delay_ms(100);
  while(PAUSE);
  delay_ms(100);
  MaSound_Restart(func,file,NULL);
 }

 goto Loop;
}
